﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=StaticCode
Version=9.8
@EndOfDesignText@
' modDB - Code module

Sub Process_Globals
	Public DBSQL As SQL
	Private mDBDir, mDBFileName As String
	Private mQuery As String
	
	' If you will need to serialize objects of type tPerson,
	' you MUST declare it in the Main Process_Globals, not here.
	Type tPerson(ID As Int, FirstName As String, LastName As String, Address As String, ProfessionID As Int)
End Sub

Public Sub Init
	mDBDir = File.DirInternal
	mDBFileName = "ForTests.db"
	If Not(File.Exists(mDBDir, mDBFileName)) Then
		File.Copy(File.DirAssets, mDBFileName, mDBDir, mDBFileName)
	End If
	DBSQL.Initialize(mDBDir, mDBFileName, False)
End Sub

' Returns a map in which the key are the IDs
' and the values are tPerson objects.
Public Sub GetAllPersons As Map
	Dim mapResult As Map
	mapResult.Initialize
	
	mQuery = "SELECT * FROM Person"
	Dim cur As Cursor
	cur = DBSQL.ExecQuery(mQuery)
	For i = 0 To cur.RowCount - 1
		cur.Position = i
		Dim Person As tPerson
		Person.Initialize
		Person.ID = cur.GetInt("ID")
		Person.FirstName = cur.GetString("FirstName")
		Person.LastName = cur.GetString("LastName")
		Person.Address = cur.GetString("Address")
		Person.ProfessionID = cur.GetInt("ProfessionID")
		mapResult.Put(Person.ID, Person)
	Next
	cur.Close
	
	Return mapResult
End Sub